"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function conversion(target) {
    if (target.__pipcook__args) {
        let args = '';
        for (let key in target) {
            if (key !== '__pipcook__args') {
                args += `${key}=${conversion(target[key])},`;
            }
        }
        return args.slice(0, args.length - 1);
    }
    else if (typeof target === 'number') {
        return target;
    }
    else if ((typeof target === 'string' || target instanceof String)) {
        return '"' + target + '"';
    }
    else if (typeof target === 'boolean') {
        if (target) {
            return 'True';
        }
        else {
            return 'False';
        }
    }
    else if (target === null || target === undefined) {
        return 'None';
    }
    else if (target.__pipcook__identifier) {
        return target.__pipcook__identifier;
    }
    else if (Array.isArray(target)) {
        return `(${target.toString()})`;
    }
    else {
        return target;
    }
}
function createProxy(object, statements) {
    const p = new Proxy(object, {
        get(target, key) {
            if (key === 'then' || typeof key !== 'string' || key === '__pipcook__identifier'
                || key === 'inspect' || key === 'prototype' || key === 'constructor'
                || key === 'call' || key === 'toString' || key === 'name' || key === '__pipcook__args') {
                return target[key];
            }
            const identifier = 'id_' + Date.now() + parseInt(String(Math.random() * 100000));
            statements.push(`${identifier} = ${target.__pipcook__identifier}.${String(key)}`);
            return getObject(identifier, statements);
        },
        apply: function (target, thisArg, argumentsList) {
            const identifier = 'id_' + Date.now() + parseInt(String(Math.random() * 100000));
            const argumentElements = argumentsList.map((ele) => conversion(ele));
            statements.push(`${identifier} = ${target.__pipcook__identifier}(${argumentElements.join(',')})`);
            return getObject(identifier, statements);
        }
    });
    return p;
}
function getObject(identifier, statements) {
    const object = () => { };
    object.__pipcook__identifier = identifier;
    const proxy = createProxy(object, statements);
    return proxy;
}
exports.getObject = getObject;
//# sourceMappingURL=python-helper.js.map